;********************************************************************************************
;This software is provided in an AS IS condition,NO WARRANTIES in any form apply to this software.

;You can use/modify  provided schematics and code without any limitations.

; picmicrolab.com 2.17.2017
;********************************************************************************************
;Basic kinetic watch winder using PIC microcontroller and stepper motor
;
;-----------------------------------------------------------------------------------
LIST 	P=PIC16F877A
include	P16f877A.inc

__CONFIG _CP_OFF & _WDT_OFF & _BODEN_OFF & _PWRTE_OFF & _HS_OSC & _LVP_OFF & _DEBUG_OFF & _CPD_OFF

lcount	equ		0x2B
ncount	equ		0x2C
mcount	equ		0x2D
UPCounter equ	0x30
DownCounter equ	0x31

	org		0x00
	reset:	nop
	goto start
    

		org		0x10
start:	bcf		STATUS, RP0
		bcf		STATUS, RP1
		clrf	PORTC
		movlw   0x0f
		movwf	TRISB

		bsf		STATUS, RP0
		movlw	0xF0
		movwf   TRISC

		bcf		STATUS, RP0



looop:
	btfss PORTB,0x00
	call Swing
	btfss PORTB,0x01
	call RotateCW
	btfss PORTB,0x02
	call RotateCCW
	
	;call        LDelay
	

	

	
goto		looop



pause	movlw		0x02
		movwf		lcount
loop3   movlw		0x45
		movwf		mcount
loop2	movlw		0x45
		movwf		ncount
loop1	decfsz		ncount,1
		goto		loop1
		decfsz		mcount,1
		goto		loop2
		decfsz		lcount,1
		goto   		loop3		
		return


LDelay
		movlw		0x05
		movwf		0x25
loopl3   movlw		0xf0
		movwf		0x26
loopl2	movlw		0xf0
		movwf		0x27
loopl1	decfsz		0x27,1
		goto		loopl1
		decfsz		0x26,1
		goto		loopl2
		decfsz		0x25,1
		goto   		loopl3		
		return

;next:	goto next

RotateCW
		movlw		0x01
		movwf		PORTC
		call		pause	; delay 
	
		movlw		0x02
		movwf		PORTC
		call		pause 	; delay 

		movlw		0x04
		movwf		PORTC
		call		pause	; delay 
	
		movlw		0x08
		movwf		PORTC
		call		pause 	; delay 

return

RotateCCW

		movlw		0x08
		movwf		PORTC
		call		pause	; delay 
	
		movlw		0x04
		movwf		PORTC
		call		pause 	; delay 

		movlw		0x02
		movwf		PORTC
		call		pause	; delay 
	
		movlw		0x01
		movwf		PORTC
		call		pause 	; delay 
return


Swing


		movlw 0x40
		movwf UPCounter
		movwf DownCounter
		

Swing1
	

		decf  UPCounter,f
		btfsc STATUS,Z
		goto  Swing2
		call  RotateCW
		goto  Swing1
		
Swing2:	
		
		decf  DownCounter,f
		btfsc STATUS,Z
		;goto  again
		return
		call  RotateCCW
		goto Swing2


return

end